load('sbbsdefs.js');
load('funclib.js');

var settings, lastread, systemName;

function main() {
    var f = new File(js.exec_dir + 'ibol.msg');
    var ascfile;
    if (f.open('r')) {
        ascfile = f.readAll();
        f.close();
    } else {
        ascfile = [''];
    }
    console.clear();
    console.printfile(js.exec_dir + 'ibolhead.msg');

    var start;
    if (ascfile.length > 18) {
        start = ascfile.length - 18;
    } else {
        start = 0;
    }

    for (var i = start; i < ascfile.length; i = i + 1) {
        console.putmsg(ascfile[i]);
        console.putmsg('\r\n');
    }

    console.putmsg('\x01h\x01w (\x01yA\x01w) \x01mAdd, \x01w(\x01yV\x01w) \x01mView All, \x01w(\x01yQ\x01w) \x01mQuit ');

    var userinput = console.getkey(K_NONE);
    var lines = [];
    if (userinput == 'a' || userinput == 'A') {
        console.clear();
        console.putmsg('\x01mAdd your message here\x01n:\r\n');
        console.putmsg('\x01h\x01w (\x01yblank line quits\x01w)\r\n');
        for (var i = 0; i < 10; i++) {
            console.putmsg('line ' + (i + 1) + ': ');
            var str = console.getstr('', 56);
            if (str.length == 0) {
                if (i == 0) {
                    return;
                } else {
                    break;
                }
            }
            lines.push([str]);
        }

        // preview and confirm before posting...
        console.putmsg(' \x01h\x01k+----------------------------------------------------------------------------+\r\n');
        for (var i = 0; i < lines.length; i++) {
            console.putmsg('\x01y\x01hPREVIEW\x01w: \x01n' + convertPipeToCtrlA(truncsp(lines[i])) + '\r\n');
        }
        console.putmsg(' \x01h\x01k+----------------------------------------------------------------------------+\r\n');
        if (console.yesno('\x01mLook OK\x01n')) {
            var header = {
                'to': 'IBBS1LINE',
                'from': user.alias,
                'subject': 'InterBBS Oneliner'
            };

            systemName = settings.systemName;
            if (systemName === "" || systemName === undefined) {
                systemName = system.name;
            }

            var body = '';

            body = body + 'Author: ' + user.alias + '\r\n';
            body = body + 'Source: ' + systemName + '\r\n';
            for (var i = 0; i < lines.length; i++) {
                body = body + 'Oneliner: ' + lines[i] + '\r\n';
            }

            var msgBase = new MsgBase(settings.messageBase);
            msgBase.open();
            msgBase.save_msg(header, body);
            msgBase.close();

            // new post was successfully added. :::::::::::::::::::::::::::::::
            // read back the wall to the user as visual feedback of what ::::::
            // was added. :::::::::::::::::::::::::::::::::::::::::::::::::::::
            readmsgbase();
            if (f.open('r')) {
                ascfile = f.readAll();
                f.close();
            } else {
                ascfile = [''];
            }
            console.clear();
            console.printfile(js.exec_dir + 'ibolhead.msg');            
            if (ascfile.length > 18) {
                start = ascfile.length - 18;
            } else {
                start = 0;
            }
            for (var i = start; i < ascfile.length; i = i + 1) {
                console.putmsg(ascfile[i]);
                console.putmsg('\r\n');
            }            
            console.putmsg(' \x01mPress a key....');
            console.getkey(K_NONE);
        }
    } else if (userinput == 'v' || userinput == 'V') {
        console.clear();
        console.printfile(js.exec_dir + 'ibolhead.msg');
        console.printfile(js.exec_dir + 'ibol.msg');
        console.putmsg(' \x01mPress a key....');
        console.getkey(K_NONE);
    }
}

function readmsgbase() {
    var msgBase = new MsgBase(settings.messageBase);
    var ascfile = new File(js.exec_dir + 'ibol.msg');

    ascfile.open('a+');

    msgBase.open();
    var start;
    if (lastread == 0) {
        start = msgBase.first_msg;
    } else {
        start = lastread + 1;
    }
    for (var m = start; m <= msgBase.last_msg; m = m + 1) {
        var h = msgBase.get_msg_header(m);
        if (h == null)
            break;
        if (h.subject === 'InterBBS Oneliner' && h.to === 'IBBS1LINE') {
            var body = msgBase.get_msg_body(m);
            var author,
            fromsys;
            var lines = [];
            var msgbody = '';
            var arrayOfLines = body.match(/[^\r\n]+/g);
            var arrayLen = arrayOfLines.length;
            for (var i = 0; i < arrayLen; i = i + 1) {
                var line = convertPipeToCtrlA(arrayOfLines[i]);
                if (line.substr(0, 8) === 'Author: ') {
                    author = truncsp(line.substr(8));
                } else if (line.substr(0, 8) === 'Source: ') {
                    fromsys = truncsp(line.substr(8));
                } else if (line.substr(0, 10) === 'Oneliner: ') {
                    msgbody = msgbody + truncsp(line.substr(10)) + ' ';
                }
            }

            var arrayOfWords = msgbody.split(' ');
            var spaceleft = 57;
            var curline = '';
            for (var i = 0; i < arrayOfWords.length; i = i + 1) {
                if (arrayOfWords[i].length > spaceleft) {
                    lines.push([curline]);
                    curline = arrayOfWords[i] + ' ';
                    spaceleft = 57 - (arrayOfWords[i].length + 1);
                } else {
                    curline = curline + arrayOfWords[i] + ' ';
                    spaceleft = spaceleft - (arrayOfWords[i].length + 1);
                }
            }
            lines.push([curline]);

            var len;

            if (lines.length > 2) {
                len = lines.length;
            } else {
                len = 2;
            }

            for (var i = 0; i < len; i = i + 1) {
                if (i == 0) {
                    if (lines.length >= 1) {
                        ascfile.printf('\x01h\x01c%s\x01k: \x01n\x01w%s\n', strictLenExcludingFormatting(author, 20), truncsp(lines[0]));
                    } else {
                        ascfile.printf('\x01h\x01c%s\x01k: \n', strictLenExcludingFormatting(author, 20));
                    }
                } else if (i == 1) {
                    if (lines.length >= 2) {
                        ascfile.printf('\x01n\x01c%s\x01h\x01k: \x01n\x01w%s\n', strictLenExcludingFormatting(fromsys, 20), truncsp(lines[1]));
                    } else {
                        ascfile.printf('\x01n\x01c%s\x01h\x01k: \n', strictLenExcludingFormatting(fromsys, 20));
                    }
                } else {
                    ascfile.printf('                    \x01h\x01k: \x01n\x01w%s\n', truncsp(lines[i]));
                }
            }
            ascfile.write(' \x01h\x01k------------------------------------------------------------------------------\x01n\x01k\n')

        }
        lastread = m;
    }
    msgBase.close();
    ascfile.close();

    var f = new File(js.exec_dir + 'ibol.lr');
    if (!f.open('w'))
        throw 'Failed to open ibol.lr.';
    f.writeBin(lastread);
    f.close();
}

/**
 * This function formats a string to a strict length
 * without counting any CTRL-A sequences torward the length.
 * The entire formatted string up to the desired length gets returned.
 * Leading whitespaces will be inserted to achieve the string's target length.
 */
function strictLenExcludingFormatting(str, targetLen) {
    var currentLen = 0;
    var newString = "";
    for (var i = 0; i < str.length && currentLen < targetLen; i++) {
        if (str.substr(i, 2).match(/\x01[0-9A-Za-z]/)) {
            newString += str.substr(i, 2); // Append the CTRL-A code, but don't
            i = i + 1;                     // count it as part of the length.
        } else {
            newString += str[i];
            currentLen = currentLen + 1;
        }
    }
    while (currentLen < targetLen) { // Insert leading whitespace until
        newString = " " + newString; // we reach the desired length.
        currentLen = currentLen + 1;
    }
    return newString;
}

function convertPipeToCtrlA(str) {
    return str.replace(/\|00/g, "\x01n\x01k\x01h" //  00   Normal Black
    ).replace(/\|01/g, "\x01n\x01b"               //  01   Normal Blue
    ).replace(/\|02/g, "\x01n\x01g"               //  02   Normal Green
    ).replace(/\|03/g, "\x01n\x01c"               //  03   Normal Cyan
    ).replace(/\|04/g, "\x01n\x01r"               //  04   Normal Red
    ).replace(/\|05/g, "\x01n\x01m"               //  05   Normal Magenta
    ).replace(/\|06/g, "\x01n\x01y"               //  06   Brown
    ).replace(/\|07/g, "\x01n\x01w"               //  07   Normal White
    ).replace(/\|08/g, "\x01k\x01h"               //  08   High Intensity Black
    ).replace(/\|09/g, "\x01b\x01h"               //  09   High Intensity Blue
    ).replace(/\|10/g, "\x01g\x01h"               //  10   High Intensity Green
    ).replace(/\|11/g, "\x01c\x01h"               //  11   High Intensity Cyan
    ).replace(/\|12/g, "\x01r\x01h"               //  12   High Intensity Red
    ).replace(/\|13/g, "\x01m\x01h"               //  13   High Intensity Magenta
    ).replace(/\|14/g, "\x01y\x01h"               //  14   Yellow
    ).replace(/\|15/g, "\x01w\x01h"               //  15   High Intensity White
    ).replace(/\|16/g, "\x010"                    //  16   Background Black
    ).replace(/\|17/g, "\x014"                    //  17   Background Blue
    ).replace(/\|18/g, "\x012"                    //  18   Background Green
    ).replace(/\|19/g, "\x016"                    //  19   Background Cyan
    ).replace(/\|20/g, "\x011"                    //  20   Background Red
    ).replace(/\|21/g, "\x015"                    //  21   Background Magenta
    ).replace(/\|22/g, "\x013"                    //  22   Background Brown
    ).replace(/\|23/g, "\x017"                    //  23   Background White
    ).replace(/\|24/g, "\x01k\x01h\x01i"          //  24   High Intensity Black Background (or blinking foreground)
    ).replace(/\|25/g, "\x01b\x01h\x01i"          //  25   High Intensity Blue Background (or blinking foreground)
    ).replace(/\|26/g, "\x01g\x01h\x01i"          //  26   High Intensity Green Background (or blinking foreground)
    ).replace(/\|27/g, "\x01c\x01h\x01i"          //  27   High Intensity Cyan Background (or blinking foreground)
    ).replace(/\|28/g, "\x01r\x01h\x01i"          //  28   High Intensity Red Background (or blinking foreground)
    ).replace(/\|29/g, "\x01m\x01h\x01i"          //  29   High Intensity Magenta Background (or blinking foreground)
    ).replace(/\|30/g, "\x01y\x01h\x01i"          //  30   High Intensity Yellow Background (or blinking foreground)
    ).replace(/\|31/g, "\x01w\x01h\x01i");        //  31   High Intensity White Background (or blinking foreground)
}

function loadSettings() {
    var f = new File(js.exec_dir + 'ibol.ini');
    if (!f.open('r'))
        throw 'Failed to open ibol.ini.';
    settings = f.iniGetObject();

    f.close();

    f = new File(js.exec_dir + 'ibol.lr');
    if (!f.open('r')) {
        lastread = 0;
    } else {
        lastread = f.readBin();
        f.close();
    }
}

function init() {
    loadSettings();
    readmsgbase();
}

try {
    init();
    main();
} catch (err) {
    log(LOG_ERR, err);
}
